module Operations where

import Types
import List

subtract :: (Num a) => [a] -> a 
subtract = foldr (-) 0

divide   :: (Fractional a) => [a] -> a
divide []  = 0
divide [r] = r
divide (h1:h2:t) = divide ((h1/h2):t)


getPos ::  GnuExpr c 
	-> (Int, Int)
getPos (Const pos _) = pos
getPos (Add   pos _) = pos
getPos (Mul   pos _) = pos
getPos (Sub   pos _) = pos
getPos (Div   pos _) = pos
getPos (Cell  pos _) = pos


getOperands ::  GnuExpr GnuCellRef  
	-> [GnuExpr GnuCellRef]
getOperands (Add _ l) = l
getOperands (Mul _ l) = l
getOperands (Sub _ l) = l
getOperands (Div _ l) = l


getRefsPos :: [GnuExpr GnuCellRef] 
	   -> [(Int,Int)]
getRefsPos [] = []
getRefsPos ((Const _ _):exprs)         = 
	getRefsPos exprs
getRefsPos ((Cell _ (CR ref _)):exprs) = 
	ref:(getRefsPos exprs)
getRefsPos (expr:exprs)                = 
	(getRefsPos (getOperands expr)) ++ getRefsPos exprs     
   


diff :: (Eq a) => [a] -> [a] -> [a]
diff = foldl (flip delete)


